import os
import sys
import shutil

def PAUSE():

    os.system('pause')
    return

def CreateFolderDestList():
    #Create local variables
    currentDirectory = os.getcwd()
    folderPathList = []

    #Read text file
    with open('SunMoonBinFileOrderList.txt') as f:
        lines = f.readlines()

        for line in lines:
            splitLine = line.split(" ")
            splitLine.pop(0)
            PokeDexNum = splitLine[-1]
            PokeDexNum = PokeDexNum.replace('\n', '')
            PokeDexNum = PokeDexNum.replace('#', '')
            splitLine.pop(-1)

            PokemonName = ''
            for text in splitLine:
                PokemonName = PokemonName + text + " "
                PokemonName = PokemonName.rstrip()

            #print(splitLine)
            #print(PokeDexNum + ' ' + PokemonName)
            folderPath = currentDirectory + '/' + (PokeDexNum + ' ' + PokemonName)
            folderPathList.append(folderPath)

    return folderPathList

def GetBinFilesDirectory():
    #Create local variables
    binFileDirectoryList = []
    currentDirectory = os.getcwd()
    workingFolderList = os.listdir(currentDirectory)

    #Read text file
    with open('SunMoonBinFileOrderList.txt') as f:
        lines = f.readlines()
        #Parse the string to get range of bin files
        for line in lines:
            splitLine = line.split(" ")
            BinFileRange = splitLine[0]
            #print(BinFileRange)

            #Remove unnecessary characters
            BinFileRange = BinFileRange.replace(':', '')
            BinFileRange = BinFileRange.split("-")
            BinFileRangeStart = BinFileRange[0]
            BinFileRangeEnd = BinFileRange[1]

            #print(BinFileRangeStart, BinFileRangeEnd)

            #Convert string to int
            BinFileRangeStart = int(BinFileRangeStart)
            BinFileRangeEnd = int(BinFileRangeEnd)

            #print(BinFileRangeStart, BinFileRangeEnd)

            #Loop
            binFileList = []
            for i in range(BinFileRangeStart, BinFileRangeEnd + 1):
                #Get all numbers in between and convert to file name
                fileName = "dec_" + str(i).zfill(5) + ".bin"
                #Append into a list
                binFileList.append(fileName)

            #print(binFileList)
            binFileDirectoryList.append(binFileList)

    #print(binFileDirectoryList)

    return binFileDirectoryList

def main():
    currentDirectory = os.getcwd()
    print(currentDirectory)

    destFolders = CreateFolderDestList()
    binFileListDirectory = GetBinFilesDirectory()

    if(len(destFolders) != len(binFileListDirectory)):
        print("Size of DestFolders and BinFileList does not correspond, aborting operation")
        return 0


    for i in range(len(destFolders)):
        folderPath = destFolders[i]
        #Create folder if not exist
        if not os.path.exists(folderPath):
            print("Created " + folderPath)
            os.makedirs(folderPath)

        #Move files to folder
        try:
            print("Moving {0} files".format(len(binFileListDirectory[i])))
            for file in binFileListDirectory[i]:
                shutil.move(currentDirectory + '/' + file, folderPath + '/' + file)
        except:
            print("Error moving file: " + file)
            userInput = input("Do you want to continue? (y)/n")
            if(userInput == "n"):
                break
            else:
                continue


    print("Sort Completed!")
    PAUSE()
    return 0

main()
#GetBinFilesDirectory()